﻿// SortStyles.jsx
// An InDesign CS3-CS5 JavaScript
// Based: SortParagraphs.jsx
// boriskasmoscow@gmail.com, www.adobeindesign.ru
// 
var MENUITEMS = 4;
var myPositions = [];

main();
function main()
{
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
	if(app.documents.length != 0)
	{
		if(app.selection.length > 0){
			switch(app.selection[0].constructor.name){
				case "Text":
				case "TextColumn":
				case "TextFrame":
					if(app.selection[0].paragraphs.length > 1){
						mySortDisplayDialog();
					}
					else{
						alert("Please select at least two paragraphs of text (or a text frame) try again.");
					}
					break;
				case "Cell":
				case "Row":
				case "Table":
				case "Column":
					alert("Этот скипт не работает в таблицах.");
					break;
				default:
					alert("Please select at least two paragraphs of text (or a text frame) try again.");
			}
		}
		else{
			alert("Выделите" + MENUITEMS +" абзацев и попробуйте еще раз");
		}
	}
	else
	{
		alert("Откройте документ и попытайтесь снова");
	}	
	
} // main()
function mySortDisplayDialog()
{
	var myDocParagraphStyleNames = myGetParagraphStyleNames();
	myDocParagraphStyleNames.unshift ("");
	var myIndex = [];
	var myOrder = [];
	var currParagraph, currentStyleName;
	var currentGroup;
	var myCleanUp;
	if(app.selection[0].constructor.name == "TextFrame"){
		myParagraphs = app.selection[0].paragraphs;
	}
	else{
		if((app.selection[0].contents == "")||(app.selection[0].paragraphs.length <= 1)){
			myParagraphs = app.selection[0].parentTextFrames[0].paragraphs;
		}
		else{
			myParagraphs = app.selection[0].paragraphs;
		}
	}

	if(myParagraphs.item(0).parentStory.insertionPoints.item(-1).index == myParagraphs.item(-1).insertionPoints.item(-1).index){
		myParagraphs.item(-1).insertionPoints.item(-1).contents = "\r";
		myCleanUp = true;
	}
	else{
		myCleanUp = false;
	}
//++++++++++++++++++++++++++++++++++++++++++++++++++
	if(myParagraphs.length%MENUITEMS)
	{
		alert("Выделенный фрагмент текста неполный. Попробуйте еще раз");
		exit();
	}
	
	var myDialog = app.dialogs.add({name:"Сортировка текста по стилям", canCancel:true});
	with(myDialog)
	{
		with(dialogColumns.add())
		{
			for(var i=0; i < MENUITEMS; i++)
			{
				with (dialogRows.add())
				{
					staticTexts.add({staticLabel:(i+1)+". "});
					myIndex[i] = dropdowns.add({stringList:myDocParagraphStyleNames, selectedIndex:0});
				}
			} // for
		}
	} // with(myDialog)
	if(myDialog.show() == true){
		for (i=0; i < MENUITEMS; i++) { myOrder[i] = myIndex[i].selectedIndex; }
		myDialog.destroy();
		var nGroup = myParagraphs.length/MENUITEMS;
		// test
		
		for(var j =0; j< nGroup; j++)
		{
			app.selection = null;
			for(i=0; i < MENUITEMS; i++)
			{
				currParagraph = myParagraphs[j*MENUITEMS+i];
				currentStyleName = currParagraph.appliedParagraphStyle.name;
				for (var k=0; k < MENUITEMS; k++)
				{
					//alert(myDocParagraphStyleNames[myOrder[k]]  + "     " +currentStyleName);
					if(myDocParagraphStyleNames[myOrder[k]] == String(currentStyleName))
					{
						myPositions[i] =k;
						break;
					} // if				
				} // for (var k=0; ....
				if(!i) 
				{ app.select(currParagraph); }
				else { app.select(currParagraph, SelectionOptions.ADD_TO); }
			}
			for(var m=0; m< myPositions.length-1; m++)
			{
				for(n =m; n < myPositions.length -1; n++) 
				{
					if(myPositions[n] == myPositions[n+1]) 
					{
						alert("Неправильное содержание группы");
						exit();
					}
				}
			}
			sortParagraphs(app.selection[0].paragraphs);
		} // for
	} // if(myDialog.show() == true)
	else{
		myDialog.destroy();
	}
	app.selection = null;
	if(myCleanUp == true){
		myParagraphs.item(0).parentStory.characters.item(-1).remove();
	}
} //mySortDisplayDialog()

function myGetParagraphStyleNames()
// Получаем список стилей абзацев 
{
	var curGroup;
	var curGroupName;
	var curNameInGroup;
	var myParagraphStyleNames = app.activeDocument.paragraphStyles.everyItem().name;
	myParagraphStyleNames.shift(); // удаление стиля No Paragraph Style
	var paraGroups = app.activeDocument.paragraphStyleGroups;
	var paraGroupsLen = paraGroups.length;
	for(var i = 0; i < paraGroupsLen; i++) {
		curGroup = paraGroups[i];
		curGroupName = paraGroups[i].name;
		curGroupStyleNames = curGroup.paragraphStyles.everyItem().name
		for (j=0; j< curGroupStyleNames.length; j++)
		{
			curNameInGroup = curGroupName +":"+ curGroupStyleNames[j];
			myParagraphStyleNames.push(curNameInGroup);
		}
	}
	return myParagraphStyleNames;
}

function getParagraphStyleByName(myStyleName)
{
	var DocParaStyles = app.activeDocument.paragraphStyles;
	var DocParaGroups = app.activeDocument.paragraphStyleGroups;
	myStyleName = ""+myStyleName;
	var pos = myStyleName.indexOf(":")
	if(pos == -1)
	{
	// стиль не в группе
	var myStyle = DocParaStyles.item(myStyleName);
		return myStyle;
	} //if
	else
	{
		var myGroupAndStyleNames = myStyleName.split(":")
		var myGroupName = myGroupAndStyleNames[0];
		var myStyleName = myGroupAndStyleNames[1];
		var myGroup =DocParaGroups.item(myGroupName);
		return myGroup.paragraphStyles.item(myStyleName);

	}
} // fnc
function sortParagraphs(myParagraphs)
{
	var myCounter, myItemMoved, myA, myB, buf
	//for(var i=0; i < myParagraphs.length; i++) { alert(myParagraphs[i])}
			do{
					myItemMoved = false;
					myCounter = 0;
					do{
						myA = myPositions[myCounter];	
						myB = myPositions[myCounter+1];
						if(myA > myB){
							myParagraphs[myCounter].move(LocationOptions.after, myParagraphs[myCounter+1]);
							myItemMoved = true;
							buf = myPositions[myCounter];
							myPositions[myCounter] = myPositions[myCounter + 1];
							myPositions[myCounter + 1] = buf;
						}
						myCounter ++;
						}while (myCounter < myParagraphs.length-1);	
					myCounter = myParagraphs.length-1;
					do{
						myA = myPositions[myCounter];
						myB = myPositions[myCounter-1];
						if(myA < myB){
							myParagraphs[myCounter].move(LocationOptions.before, myParagraphs[myCounter-1]);
							myItemMoved = true;
							buf = myPositions[myCounter-1];
							myPositions[myCounter-1] = myPositions[myCounter];
							myPositions[myCounter] = buf;
						}
						myCounter --;
					}while(myCounter > 1);
				}while(myItemMoved != false);
}
